Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/dimension.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/dimension.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/dimension.f90	(revision 5600)
@@ -526,100 +643,124 @@
 
    END SUBROUTINE dim__print_unit
-   !> @endcode
+   !-------------------------------------------------------------------
+   !> @brief This function fill unused dimension of an array of dimension
+   !> and return a 4 elts array of dimension structure. 
+   !> @details
+   !> output dimensions 'x','y','z' and 't' are all informed.
+   !>
+   !> @note without input array of dimension, return 
+   !> a 4 elts array of dimension structure all unused
+   !> (case variable 0d)
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !>
+   !> @param[in] td_dim array of dimension structure
+   !> @return  4elts array of dimension structure
+   !-------------------------------------------------------------------
+   FUNCTION dim_fill_unused(td_dim)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TDIM), DIMENSION(:), INTENT(IN), OPTIONAL :: td_dim
+
+      ! function
+      TYPE(TDIM), DIMENSION(ip_maxdim) :: dim_fill_unused
+
+      ! local variable
+      CHARACTER(LEN=lc)                       :: cl_dimin
+      INTEGER(i4)      , DIMENSION(1)         :: il_ind  ! index
+      
+      TYPE(TDIM),        DIMENSION(ip_maxdim) :: tl_dim
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      IF( PRESENT(td_dim) )THEN
+         tl_dim(1:SIZE(td_dim(:)))=td_dim(:)
+      ENDIF
+      ! concatenate short nem dimension in a character string
+      cl_dimin=fct_lower(fct_concat(tl_dim(:)%c_sname))
+      DO ji = 1, ip_maxdim
+
+         ! search missing dimension
+         IF( INDEX(cl_dimin,TRIM(fct_lower(cp_dimorder(ji:ji)))) == 0 )THEN
+            ! search first empty dimension
+            il_ind(:)=MINLOC( tl_dim(:)%i_2xyzt, tl_dim(:)%i_2xyzt == 0 )
+
+            ! put missing dimension instead of empty one
+            tl_dim(il_ind(1))%c_sname=fct_lower(cp_dimorder(ji:ji))
+            ! update output structure
+            tl_dim(il_ind(1))%c_name=fct_lower(cp_dimorder(ji:ji))
+            tl_dim(il_ind(1))%i_2xyzt=ji
+            tl_dim(il_ind(1))%i_len=1
+            tl_dim(il_ind(1))%l_use=.FALSE.
+         ENDIF
+
+      ENDDO
+         
+      ! save result
+      dim_fill_unused(:)=tl_dim(:)
+
+      ! clean
+      CALL dim_clean(tl_dim(:))
+
+   END FUNCTION dim_fill_unused
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine check if dimension are ordered or not 
-   !
-   !> @author J.Paul
-   !> - 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @return dimension are ordered or not 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dim_order(td_dim)
+   !> This subroutine switch element of an array (4 elts) of dimension 
+   !> structure 
+   !> from unordered dimension to ordered dimension <br/>
+   !>
+   !> @details
+   !> Optionally you could specify dimension order to output
+   !> (default 'xyzt')
+   !> Example: (/'z','x','t','y'/) => (/'x','y','z','t'/)
+   !>
+   !> @warning this subroutine change dimension order 
+   !
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !> @date September, 2014 - allow to choose ordered dimension to be output
+   !>
+   !> @param[inout] td_dim    array of dimension structure
+   !> @param[in] cd_dimorder  dimension order to be output 
+   !-------------------------------------------------------------------
+   SUBROUTINE dim_reorder(td_dim, cd_dimorder)
       IMPLICIT NONE
       ! Argument      
-      TYPE(TDIM), DIMENSION(:), INTENT(IN) :: td_dim
-
-      ! function
-      LOGICAL :: dim_order
+      TYPE(TDIM)              , DIMENSION(:), INTENT(INOUT) :: td_dim
+      CHARACTER(LEN=ip_maxdim)              , INTENT(IN   ), OPTIONAL :: cd_dimorder
 
       ! local variable
-      CHARACTER(LEN=lc) :: cl_dimin
-
-      ! loop indices
-      !----------------------------------------------------------------
-      ! init
-      dim_order=.FALSE.
+      INTEGER(i4)                             :: il_ind
+
+      CHARACTER(LEN=lc)                       :: cl_dimin
+      CHARACTER(LEN=lc)                       :: cl_dimorder
+
+      TYPE(TDIM)       , DIMENSION(ip_maxdim) :: tl_dim
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
 
       IF( SIZE(td_dim(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension.")
+         CALL logger_error("DIM REORDER: invalid dimension of array dimension.")
       ELSE
 
-         cl_dimin=fct_concat(td_dim(:)%c_sname)
-
-         IF( TRIM(cp_dimorder) == TRIM(cl_dimin) )THEN
-            dim_order=.TRUE.
-         ENDIF
-
-      ENDIF
-   END FUNCTION dim_order
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief 
-   !> This subroutine switch element of a table (4 elts) of dimension 
-   !> structure 
-   !> from unordered dimension to ordered dimension ('x','y','z','t')
-   !> Example: (/'z','x','t','y'/) => (/'x','y','z','t'/)
-   !> @warning this subroutine change dimension order 
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_dim : table of dimension structure
-   !> @return dimension structure completed and reordered 
-   !>
-   !> @todo
-   !> -check input dimension order and stop if already ordered
-   !> - 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE dim_reorder(td_dim)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TDIM), DIMENSION(:), INTENT(INOUT) :: td_dim
-
-      ! local variable
-      INTEGER(i4)                             :: il_id
-      CHARACTER(LEN=lc)                       :: cl_dimin
-      TYPE(TDIM)       , DIMENSION(ip_maxdim) :: tl_dim
-
-      ! loop indices
-      INTEGER(i4) :: ji
-      INTEGER(i4) :: jj
-      !----------------------------------------------------------------
-
-      IF( SIZE(td_dim(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension.")
-      ELSE
-
-         ! copy and rename dimension in local variable
-         tl_dim(:)=td_dim(:)
-         jj=0
+         cl_dimorder=TRIM(cp_dimorder)
+         IF( PRESENT(cd_dimorder) ) cl_dimorder=TRIM(ADJUSTL(cd_dimorder))
+
+         ! add id if dimension used and no id
          DO ji=1, ip_maxdim
 
-         CALL logger_debug( "DIM REORDER : jj "//TRIM(fct_str(jj))//&
-         &  " "//TRIM(fct_str(td_dim(ji)%l_use)))
             IF( td_dim(ji)%l_use )THEN
-               jj=jj+1
-            !IF( td_dim(ji)%l_use .AND. td_dim(ji)%i_id == 0 )THEN
-               ! add id if dimension used and no id
-               CALL logger_debug( "DIM REORDER : add id "//TRIM(fct_str(jj))//&
-               &  " to dimension "//TRIM(td_dim(ji)%c_name) )
-               tl_dim(ji)%i_id=jj
+               IF( td_dim(ji)%i_id == 0 )THEN
+                  td_dim(ji)%i_id=MAXVAL(td_dim(:)%i_id)+1
+               ENDIF
             ELSE
                td_dim(ji)%i_id=0
                td_dim(ji)%i_xyzt2=0
+               td_dim(ji)%i_2xyzt=0
                td_dim(ji)%c_sname='u'
                td_dim(ji)%c_name=''
@@ -629,20 +770,14 @@
          ENDDO
 
-         print *,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
-         CALL dim_print(tl_dim(:))
-
-
          ! fill unused dimension
-         CALL dim__fill_unused(tl_dim(:))
+         tl_dim(:)=dim_fill_unused(td_dim(:))
          cl_dimin=fct_lower(fct_concat(tl_dim(:)%c_sname))
 
-         print *,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
-         CALL dim_print(tl_dim(:))
          ! compute input id from output id (xyzt) 
          DO ji = 1, ip_maxdim
              
-            il_id=SCAN(TRIM(cp_dimorder),TRIM(cl_dimin(ji:ji)))
-            IF( il_id /= 0 )THEN
-               tl_dim(ji)%i_xyzt2=il_id
+            il_ind=SCAN(TRIM(cl_dimorder),TRIM(cl_dimin(ji:ji)))
+            IF( il_ind /= 0 )THEN
+               tl_dim(ji)%i_xyzt2=il_ind
             ENDIF
             
@@ -652,7 +787,7 @@
          DO ji = 1, ip_maxdim
              
-            il_id=SCAN(TRIM(cl_dimin),TRIM(cp_dimorder(ji:ji)))
-            IF( il_id /= 0 )THEN
-               tl_dim(ji)%i_2xyzt=il_id
+            il_ind=SCAN(TRIM(cl_dimin),TRIM(cl_dimorder(ji:ji)))
+            IF( il_ind /= 0 )THEN
+               tl_dim(ji)%i_2xyzt=il_ind
             ENDIF
             
@@ -669,24 +804,22 @@
          td_dim(:)%i_xyzt2 = tl_dim(:)%i_xyzt2
 
+         ! clean
+         CALL dim_clean(tl_dim(:))
       ENDIF
 
    END SUBROUTINE dim_reorder
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief 
-   !> This subroutine switch dimension table from ordered dimension ('x','y','z','t')
-   !> to unordered dimension.<br/>
+   !-------------------------------------------------------------------
+   !> @brief This subroutine switch dimension array from ordered dimension ('x','y','z','t')
+   !> to unordered dimension. <br/>
+   !> @details
    !> Example: (/'x','y','z','t'/) => (/'z','x','t','y'/)<br/>
-   !> This is useful to add dimension in a variable or file
-   !
+   !  This is useful to add dimension in a variable or file.
    !> @warning this subroutine change dimension order 
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_dim : table of dimension structure
-   !> @return dimension structure unordered 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[inout] td_dim array of dimension structure
+   !-------------------------------------------------------------------
    SUBROUTINE dim_unorder(td_dim)
       IMPLICIT NONE
@@ -702,7 +835,7 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension.")
+         CALL logger_error("DIM UNORDER: invalid dimension of array dimension.")
       ELSE      
-         ! add dummy xyzt2 id to removed dimension
+         ! add dummy xyzt2 id to unused dimension
          jj=1
          DO ji = 1, ip_maxdim
@@ -729,6 +862,4 @@
                td_dim(ji)%i_xyzt2=0
                td_dim(ji)%c_sname='u'
-               !td_dim(ji)%c_name='unknown'
-               !td_dim(ji)%c_sname=''
                td_dim(ji)%c_name=''
                td_dim(ji)%l_uld=.FALSE.
@@ -738,79 +869,21 @@
 
    END SUBROUTINE dim_unorder
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine filled dimension structure with unused 
-   !> dimension in order that all dimensions 'x','y','z' and 't' be
-   !> informed, even if void 
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_dim : table of dimension structure
-   !> @return td_dim with unused dimension
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE dim__fill_unused(td_dim)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TDIM), DIMENSION(:), INTENT(INOUT) :: td_dim
-
-      ! local variable
-      CHARACTER(LEN=lc)               :: cl_dimin
-      INTEGER(i4)      , DIMENSION(1) :: il_ind  ! index
-      
-      ! loop indices
-      INTEGER(i4) :: ji
-      !----------------------------------------------------------------
-
-      IF( SIZE(td_dim(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension.")
-      ELSE      
-         ! concatenate dimension used in a character string
-         cl_dimin=fct_lower(fct_concat(td_dim(:)%c_sname))
-         DO ji = 1, ip_maxdim
-
-            ! search missing dimension
-            IF( INDEX(cl_dimin,TRIM(fct_lower(cp_dimorder(ji:ji)))) == 0 )THEN
-               ! search first empty dimension
-               il_ind(:)=MINLOC( td_dim(:)%i_id, td_dim(:)%i_id == 0 )
-
-               ! put missing dimension instead of empty one
-               td_dim(il_ind(1))%c_sname=fct_lower(cp_dimorder(ji:ji))
-               ! update output structure
-               td_dim(il_ind(1))%c_name=fct_lower(cp_dimorder(ji:ji))
-               td_dim(il_ind(1))%i_id=il_ind(1)
-               td_dim(il_ind(1))%i_len=1
-               td_dim(il_ind(1))%l_use=.FALSE.
-
-            ENDIF
-
-         ENDDO
-
-         ! remove id of unused dimension
-         DO ji = 1, ip_maxdim
-            IF( .NOT. td_dim(ji)%l_use ) td_dim(ji)%i_id=0
-         ENDDO
-      ENDIF
-
-   END SUBROUTINE dim__fill_unused
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine reshape real(8) 4D table   
-   !> to an ordered table with dimension (/'x','y','z','t'/).<br/>
+   !-------------------------------------------------------------------
+   !> @brief This function reshape real(8) 4D array   
+   !> to an ordered array, as defined by dim_reorder.<br/>
+   !> @details
    !> Example: (/'z','x','t','y'/) => (/'x','y','z','t'/)
    !
    !> @note you must have run dim_reorder before use this subroutine
    !
-   !> @warning output table dimension differ from input table dimension
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] dd_value : table of value to reshape
-   !> @return table of value reshaped 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @warning output array dimension differ from input array dimension
+   !
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim    array of dimension structure
+   !> @param[in] dd_value  array of value to reshape
+   !> @return array of value reshaped 
+   !-------------------------------------------------------------------
    FUNCTION dim__reshape_2xyzt_dp(td_dim, dd_value)
       IMPLICIT NONE
@@ -835,5 +908,5 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension.")
+         CALL logger_error("DIM RESHAPE 2 XYZT: invalid dimension of array dimension.")
       ELSE      
 
@@ -841,5 +914,5 @@
 
             CALL logger_fatal( &
-            &  "  RESHAPE to XYZT: you should have run dim_reorder &
+            &  "  DIM RESHAPE 2 XYZT: you should have run dim_reorder &
             &     before running RESHAPE" )
 
@@ -854,10 +927,10 @@
 
             DO ji=1,ip_maxdim
-               CALL logger_debug(" RESHAPE to XYZT: dim "//&
+               CALL logger_debug(" DIM RESHAPE 2 XYZT: dim "//&
                &     TRIM(td_dim(td_dim(ji)%i_xyzt2)%c_name)//" "//&
                &     TRIM(fct_str(td_dim(td_dim(ji)%i_xyzt2)%i_len))//" vs "//&
                &     TRIM(fct_str(il_shape(ji))) )
             ENDDO
-            CALL logger_fatal(" RESHAPE to XYZT: wrong input dimensions " )
+            CALL logger_fatal(" DIM RESHAPE 2 XYZT: wrong input dimensions " )
 
          ELSE
@@ -870,5 +943,5 @@
             cl_dim=TRIM(cl_dim)//TRIM(fct_str(il_shape(ip_maxdim)))//"/)"
 
-            CALL logger_info(" RESHAPE to XYZT: input dimensions are "//&
+            CALL logger_debug(" DIM RESHAPE 2 XYZT: input dimensions are "//&
             &  TRIM(cl_dim) )
 
@@ -879,5 +952,5 @@
             cl_dim=TRIM(cl_dim)//TRIM(fct_str(td_dim(ip_maxdim)%i_len))//"/)"
 
-            CALL logger_info(" RESHAPE to XYZT: ouput dimensions should be "//&
+            CALL logger_debug(" DIM RESHAPE 2 XYZT: ouput dimensions should be "//&
             &  TRIM(cl_dim) )
 
@@ -897,22 +970,21 @@
 
    END FUNCTION dim__reshape_2xyzt_dp
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine reshape ordered real(8) 4D table with dimension 
-   !> (/'x','y','z','t'/) to a table ordered as file variable.<br/>
+   !-------------------------------------------------------------------
+   !> @brief This function reshape ordered real(8) 4D array with dimension 
+   !> (/'x','y','z','t'/) to an "unordered" array.<br/>
+   !> @details
    !> Example: (/'x','y','z','t'/) => (/'z','x','t','y'/)
    !
    !> @note you must have run dim_reorder before use this subroutine
    !
-   !> @warning output table dimension differ from input table dimension
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] dd_value : table of value to reshape
-   !> @return table of value reshaped 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @warning output array dimension differ from input array dimension
+   !
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim    array of dimension structure
+   !> @param[in] dd_value  array of value to reshape
+   !> @return array of value reshaped 
+   !-------------------------------------------------------------------
    FUNCTION dim__reshape_xyzt2_dp(td_dim, dd_value)
       IMPLICIT NONE
@@ -937,5 +1009,5 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension.")
+         CALL logger_error("DIM RESHAPE XYZT 2: invalid dimension of array dimension.")
       ELSE
 
@@ -943,5 +1015,5 @@
 
             CALL logger_fatal( &
-            &  "  RESHAPE from XYZT: you should have run dim_reorder &
+            &  "  DIM RESHAPE XYZT 2: you should have run dim_reorder &
             &     before running RESHAPE" )
 
@@ -953,10 +1025,10 @@
 
             DO ji=1,ip_maxdim
-               CALL logger_debug(" RESHAPE from XYZT: dim "//&
+               CALL logger_trace(" DIM RESHAPE XYZT 2: dim "//&
                &              TRIM(td_dim(ji)%c_name)//" "//&
                &              TRIM(fct_str(td_dim(ji)%i_len))//" vs "//&
                &              TRIM(fct_str(il_shape(ji))) )
             ENDDO
-            CALL logger_fatal( "RESHAPE from XYZT: wrong input dimensions ")
+            CALL logger_fatal( "DIM RESHAPE XYZT 2: wrong input dimensions ")
 
          ELSE      
@@ -969,5 +1041,5 @@
             cl_dim=TRIM(cl_dim)//TRIM(fct_str(il_shape(ip_maxdim)))//"/)"
 
-            CALL logger_info(" RESHAPE from XYZT: input dimensions are "//&
+            CALL logger_debug(" DIM RESHAPE XYZT 2: input dimensions are "//&
             &  TRIM(cl_dim) )
 
@@ -980,8 +1052,8 @@
             &      TRIM(fct_str(td_dim(td_dim(ip_maxdim)%i_xyzt2)%i_len))//"/)"
 
-            CALL logger_info(" RESHAPE from XYZT: ouput dimensions should be "//&
+            CALL logger_debug(" DIM RESHAPE XYZT 2: ouput dimensions should be "//&
             &  TRIM(cl_dim) )
 
-            ! reshape table
+            ! reshape array
             dim__reshape_xyzt2_dp(:,:,:,:)=RESHAPE(SOURCE=dd_value,  &
             &           SHAPE = (/ td_dim(td_dim(1)%i_xyzt2)%i_len,   &
@@ -994,29 +1066,26 @@
             &                             td_dim(4)%i_xyzt2        /))
 
-
          ENDIF      
       ENDIF      
 
    END FUNCTION dim__reshape_xyzt2_dp
-   !> @endcode    
-   !-------------------------------------------------------------------
-   !> @brief  This subroutine reordered integer(4) 1D table to be suitable 
-   !> with dimension ordered as (/'x','y','z','t'/)
+   !-------------------------------------------------------------------
+   !> @brief  This function reordered integer(4) 1D array to be suitable 
+   !> with dimension ordered as defined in dim_reorder.
    !> @note you must have run dim_reorder before use this subroutine
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] id_tab : table of value to reshape
-   !> @return table of value reshaped 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dim__reorder_2xyzt_i4(td_dim, id_tab)
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim array of dimension structure
+   !> @param[in] id_arr array of value to reshape
+   !> @return array of value reshaped 
+   !-------------------------------------------------------------------
+   FUNCTION dim__reorder_2xyzt_i4(td_dim, id_arr)
       IMPLICIT NONE
 
       ! Argument      
       TYPE(TDIM) , DIMENSION(:), INTENT(IN) :: td_dim
-      INTEGER(i4), DIMENSION(:), INTENT(IN) :: id_tab
+      INTEGER(i4), DIMENSION(:), INTENT(IN) :: id_arr
       
       ! function
@@ -1028,12 +1097,12 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim .OR. &
-      &   SIZE(id_tab(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension"//&
-         &              " or of table of value.")
+      &   SIZE(id_arr(:)) /= ip_maxdim )THEN
+         CALL logger_error("DIM REORDER 2 XYZT: invalid dimension of array dimension"//&
+         &              " or of array of value.")
       ELSE      
          IF( ANY(td_dim(:)%i_2xyzt==0) )THEN
 
             CALL logger_error( &
-            &  "  REORDER to XYZT: you should have run dim_reorder &
+            &  "  DIM REORDER 2 XYZT: you should have run dim_reorder &
             &     before running REORDER" )
 
@@ -1041,29 +1110,27 @@
 
          DO ji=1,ip_maxdim
-            dim__reorder_2xyzt_i4(ji)=id_tab(td_dim(ji)%i_2xyzt)
+            dim__reorder_2xyzt_i4(ji)=id_arr(td_dim(ji)%i_2xyzt)
          ENDDO
       ENDIF
 
    END FUNCTION dim__reorder_2xyzt_i4
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine reordered integer(4) 1D table to be suitable with
-   !> dimension read in the file.
+   !-------------------------------------------------------------------
+   !> @brief This function unordered integer(4) 1D array to be suitable with
+   !> initial dimension order (ex: dimension read in file).
    !> @note you must have run dim_reorder before use this subroutine
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] id_tab : table of value to reshape
-   !> @return table of value reshaped 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dim__reorder_xyzt2_i4(td_dim, id_tab)
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim array of dimension structure
+   !> @param[in] id_arr array of value to reshape
+   !> @return array of value reshaped 
+   !-------------------------------------------------------------------
+   FUNCTION dim__reorder_xyzt2_i4(td_dim, id_arr)
       IMPLICIT NONE
 
       ! Argument      
       TYPE(TDIM) , DIMENSION(:), INTENT(IN) :: td_dim
-      INTEGER(i4), DIMENSION(:), INTENT(IN) :: id_tab
+      INTEGER(i4), DIMENSION(:), INTENT(IN) :: id_arr
       
       ! function
@@ -1075,12 +1142,12 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim .OR. &
-      &   SIZE(id_tab(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension"//&
-         &              " or of table of value.")
+      &   SIZE(id_arr(:)) /= ip_maxdim )THEN
+         CALL logger_error("DIM REORDER XYZT 2: invalid dimension of array dimension"//&
+         &              " or of array of value.")
       ELSE      
          IF( ANY(td_dim(:)%i_xyzt2==0) )THEN
 
             CALL logger_error( &
-            &  "  REORDER from XYZT: you should have run dim_reorder &
+            &  "  DIM REORDER XYZT 2: you should have run dim_reorder &
             &     before running REORDER" )
 
@@ -1088,28 +1155,26 @@
 
          DO ji=1,ip_maxdim
-            dim__reorder_xyzt2_i4(ji)=id_tab(td_dim(ji)%i_xyzt2)
+            dim__reorder_xyzt2_i4(ji)=id_arr(td_dim(ji)%i_xyzt2)
          ENDDO
       ENDIF
 
    END FUNCTION dim__reorder_xyzt2_i4
-   !> @endcode    
-   !-------------------------------------------------------------------
-   !> @brief  This subroutine reordered logical 1D table to be suitable 
-   !> with dimension ordered as (/'x','y','z','t'/)
+   !-------------------------------------------------------------------
+   !> @brief  This function reordered logical 1D array to be suitable 
+   !> with dimension ordered as defined in dim_reorder.
    !> @note you must have run dim_reorder before use this subroutine
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] ld_tab : table of value to reordered
-   !> @return table of value reordered 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dim__reorder_2xyzt_l(td_dim, ld_tab)
+   !> @date Nov, 2013 - Initial Version
+   !
+   !> @param[in] td_dim array of dimension structure
+   !> @param[in] ld_arr array of value to reordered
+   !> @return array of value reordered 
+   !-------------------------------------------------------------------
+   FUNCTION dim__reorder_2xyzt_l(td_dim, ld_arr)
       IMPLICIT NONE
       ! Argument      
       TYPE(TDIM) , DIMENSION(:), INTENT(IN) :: td_dim
-      LOGICAL    , DIMENSION(:), INTENT(IN) :: ld_tab
+      LOGICAL    , DIMENSION(:), INTENT(IN) :: ld_arr
       
       ! function
@@ -1121,12 +1186,12 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim .OR. &
-      &   SIZE(ld_tab(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension"//&
-         &              " or of table of value.")
+      &   SIZE(ld_arr(:)) /= ip_maxdim )THEN
+         CALL logger_error("DIM REORDER 2 XYZT: invalid dimension of array dimension"//&
+         &              " or of array of value.")
       ELSE      
          IF( ANY(td_dim(:)%i_2xyzt==0) )THEN
 
             CALL logger_error( &
-            &  "  REORDER to XYZT: you should have run dim_reorder &
+            &  "  DIM REORDER 2 XYZT: you should have run dim_reorder &
             &     before running REORDER" )
 
@@ -1134,29 +1199,27 @@
 
          DO ji=1,ip_maxdim
-            dim__reorder_2xyzt_l(ji)=ld_tab(td_dim(ji)%i_2xyzt)
+            dim__reorder_2xyzt_l(ji)=ld_arr(td_dim(ji)%i_2xyzt)
          ENDDO
       ENDIF
 
    END FUNCTION dim__reorder_2xyzt_l
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine reordered logical 1D table to be suitable with
-   !> dimension read in the file.
+   !-------------------------------------------------------------------
+   !> @brief This function unordered logical 1D array to be suitable with
+   !> initial dimension order (ex: dimension read in file).
    !> @note you must have run dim_reorder before use this subroutine
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] ld_tab : table of value to reordered
-   !> @return table of value reordered 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dim__reorder_xyzt2_l(td_dim, ld_tab)
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim array of dimension structure
+   !> @param[in] ld_arr array of value to reordered
+   !> @return array of value reordered 
+   !-------------------------------------------------------------------
+   FUNCTION dim__reorder_xyzt2_l(td_dim, ld_arr)
       IMPLICIT NONE
 
       ! Argument      
       TYPE(TDIM) , DIMENSION(:), INTENT(IN) :: td_dim
-      LOGICAL    , DIMENSION(:), INTENT(IN) :: ld_tab
+      LOGICAL    , DIMENSION(:), INTENT(IN) :: ld_arr
       
       ! function
@@ -1168,12 +1231,12 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim .OR. &
-      &   SIZE(ld_tab(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension"//&
-         &              " or of table of value.")
+      &   SIZE(ld_arr(:)) /= ip_maxdim )THEN
+         CALL logger_error("DIM REORDER XYZT 2: invalid dimension of array dimension"//&
+         &              " or of array of value.")
       ELSE
          IF( ANY(td_dim(:)%i_xyzt2==0) )THEN
 
             CALL logger_error( &
-            &  "  REORDER from XYZT: you should have run dim_reorder &
+            &  "  DIM REORDER XYZT 2: you should have run dim_reorder &
             &     before running REORDER" )
 
@@ -1181,28 +1244,26 @@
 
          DO ji=1,ip_maxdim
-            dim__reorder_xyzt2_l(ji)=ld_tab(td_dim(ji)%i_xyzt2)
+            dim__reorder_xyzt2_l(ji)=ld_arr(td_dim(ji)%i_xyzt2)
          ENDDO
       ENDIF
 
    END FUNCTION dim__reorder_xyzt2_l
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief  This subroutine reordered string 1D table to be suitable 
-   !> with dimension ordered as (/'x','y','z','t'/)
+   !-------------------------------------------------------------------
+   !> @brief  This function reordered string 1D array to be suitable 
+   !> with dimension ordered as defined in dim_reorder.
    !> @note you must have run dim_reorder before use this subroutine
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !> @param[in] cd_tab : table of value to reordered
-   !> @return table of value reordered 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dim__reorder_2xyzt_c(td_dim, cd_tab)
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim array of dimension structure
+   !> @param[in] cd_arr array of value to reordered
+   !> @return array of value reordered 
+   !-------------------------------------------------------------------
+   FUNCTION dim__reorder_2xyzt_c(td_dim, cd_arr)
       IMPLICIT NONE
       ! Argument      
       TYPE(TDIM),       DIMENSION(:), INTENT(IN) :: td_dim
-      CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) :: cd_tab
+      CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) :: cd_arr
       
       ! function
@@ -1214,12 +1275,12 @@
 
       IF( SIZE(td_dim(:)) /= ip_maxdim .OR. &
-      &   SIZE(cd_tab(:)) /= ip_maxdim )THEN
-         CALL logger_error("DIM ORDER: invalid dimension of table dimension"//&
-         &              " or of table of value.")
+      &   SIZE(cd_arr(:)) /= ip_maxdim )THEN
+         CALL logger_error("DIM REORDER 2 XYZT: invalid dimension of array dimension"//&
+         &              " or of array of value.")
       ELSE      
          IF( ANY(td_dim(:)%i_2xyzt==0) )THEN
 
             CALL logger_error( &
-            &  "  REORDER to XYZT: you should have run dim_reorder"//&
+            &  "  DIM REORDER 2 XYZT: you should have run dim_reorder"//&
             &  " before running REORDER" )
 
